;
;	Digitlis hanglejtszs stream-elssel VT-DOS-ra
;
;
;

;
;
;	Gyakrabban hasznlt mintavteli frekvencik:
;
;	pitch  minta/sec
;	4071	7812,5
;	4072	8138,0
;	4073	8491,8
;	4074	8877,8
;	4075	9300,6
;	4076	9765,6
;

pitch	.dw	0000h			; mintavteli frekvencia pitch rtke
;
rd_data	.dw	0000h			; lejtszand adatok tltsi cme
nblokk	.dw	0000h			; lejtszand fjl 8kB-os blokkjainak szma
lsblokk	.dw	0000h			; lejtszand fjl utols nem 8kB-os blokkjban lv bjtok szma
;
playadr	.dw	0000h			; aktulisan lejtszott mintabjt cme
sample	.dw	0000h			; aktulisan lejtszott mintabjt s bjton belli szmll
;
progres	.dw	0000h			; a legals sor invertlsnak pozcija
ivector	.db	000h			; I regiszter mentett rtke megszakts-tlltskor
Port3	.db	000h			; Port3 indulskori rtke
Port5	.db	000h			; Port5 indulskori rtke
;
nulpath	.db	000h			; nulla hosszsg tvonalnv



;
;
;	Hang megszakts engedlyezse, lejtszs alaphelyzetbe lltsa
;
setsnd:	di				; megszak. tilt	
	ld	hl,00010h		; lejtszs inicializlsa (fejlc 16 bjtjt tlpi)
	ld	(playadr),hl		; adatok kezdete
	ld	hl,00200h		; H = az aktulis adatbjtban htralv mintk szma
	ld	(sample),hl
	ld	hl,(pitch)		; HL= lejtszsi sebessg PITCH rtke
	ld	a,l
	out	(004h),a		; PITCH als 8 bit belltsa
	ld	a,(Port5)		; A= Port5 tkrkpe
	and	0C0h			; fels 2 bit megtartsa
	or	h			; j PITCH rtk az als 4 bitbe
	or	020h			; hang IT engedlyezse
	out	(005h),a		; kirs a portra
	ld	a,00Ah
	out	(070h),a		; CRTC bels regiszternek kivlasztsa (R10)
	ld	a,003h
	or	020h			; kurzor tiltsa
	out	(071h),a		; bels regiszter j rtknek bersa
	ld	hl,sndint		; HL= belltand megszak. kiszolgl kezd cme
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	(0039h),hl		; ugrutasts clcm bersa
	ld	a,i
	ld	(ivector),a		; megszaktsvektor mentse
	im	1			; 1-es megszaktsi md belltsa
	ei				; megszak. eng.
	ret


;
;
;	Eredeti megszakts visszalltsa
;
resint:	di				; megszak. tilt
	ld	a,(Port5)		; A reg.= Port5 eredeti rtke
	out	(005h),a		; Port5 helyrelltsa
	ld	a,00Ah			; CRTC R10-es regiszterben a kurzor engedlyezse
	out	(070h),a
	ld	a,003h
	out	(071h),a
	ld	a,(ivector)		; megszaktsvektor helyrelltsa
	ld	i,a
	im	2			; 2-es megszaktsi md belltsa
	ei				; megszak. eng.
	ret


;
;
;	Sajt megszakts-kiszolgl rutin hanglejtszshoz
;
sndint:	di				; tovbbi megszak. tilt
	push	af			; A reg. mentse
	out	(007h),a		; kurzor/hang megszak. krs trlse
	push	hl
	call	sndply			; hanglejtsz rutin hvsa
	pop	hl
	pop	af			; A reg. vissza
	ei				; megszak. eng
	ret				; visszatrs


;
;
;	Hang lejtszsa (4bit/minta)
;
sndply:	ld	hl,(sample)
	ld	a,l			; aktulis adatbjt A reg.-be
	dec	h
	jr	nz,sndpl0		; ugrs, ha mg az els mintt kell kiadni
	rlca				; a msodik minthoz ktszer balra kell lptetni az adatbjtot
	rlca
	and	03Ch			; a 4 bites amplitd rtk maszkolsa (bit0..1 -> grafikus zemmd)
mod1:	or	080h			; nyomtat nSTROBE jelt 1-be lltja (bit7, alacsony aktv)
	out	(006h),a		; amplitd bersa a portba
	ld	hl,(playadr)		; HL-ben az aktulisan jtszott mintabjt cme
	inc	hl			; cm nvelse
	res	7,h			; cm fels kt bitje 01b -> U1 RAM cmzse
	set	6,h
	ld	(playadr),hl
	ld	l,(hl)			; L= a kvetkez 2 mintt tartalmaz bjt
	ld	h,002h			; H= 2 minta van a bjtban
	ld	(sample),hl		; minta jellemzi a sajt vltozba
	ret
;
sndpl0:	rrca				; az els minthoz ktszer jobbra kell lptetni az adatbjtot
	rrca
	and	03Ch			; a 4 bites amplitd rtk maszkolsa (bit0..1 -> grafikus zemmd)
mod2:	or	080h			; nyomtat nSTROBE jelt 1-be lltja (bit7, alacsony aktv)
	out	(006h),a		; amplitd bersa a portba
	ld	(sample),hl		; frisstett szmll vissza
	ret


;
;
;	Q (kilps) billenty llapotnak beolvassa
;	in: -
;	out:  C - ESC karakterkdja vagy 0
;	     ZF - ZF=1 valamelyik vizsgland billentyt lenyomtk
;
chesc:	ld	a,(Port3)		; A reg.= Port3 tkrkpe (billentyzetsor)
	and	0F0h			; fels 4 bit meghagyva
	or	002h			; a 2. sor kivlasztsa	
	out	(003h),a		; sor belltsa a porton
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	bit	6,a			; Q billenty ellenrzse
	ld	c,01Bh			; C= ESC karakterkdja
	ret	z			; visszatrs, ha ESC-et (Q-t) nyomtak
	ld	c,000h			; egybknt C=0 -val tr vissza, ZF=0
	ret


;
;
;	Progresszbr sornak trlse a kpernyn
;	in:  -
;	out: -
;
clrpbar:ld	hl,08000h + (239 * 64)	; HL= legals sor kezdete a vidememriban
	ld	(progres),hl		; itt kell majd kezdeni az invertlst is
	ld	(hl),000h
	ld	d,h
	ld	e,l
	inc	de
	ld	bc,63			; legals sor trlse, itt lesz a progresszbr
	ldir
	ret


;
;
;	Vrakozs a lejtszsra s progresszbr lptetse
;	in:  DE - elrend lejtszsi cm
;	out: DE - megrzdik
;
pbwait:	xor	a			; A reg.= szmll az invertland bjt lptetshez
	ld	bc,(progres)		; aktulisan invertland kpbjt cme
pwait0:	halt				; vrakozs a megszaktsra
	inc	a
	bit	6,a
	jr	z,pwait1		; ugrs, ha A reg. mg nem 64
	ld	a,(bc)			; kpbjt beolvassa
	cpl
	ld	(bc),a			; invertlt kpbjt visszarsa
	inc	c
	set	6,c			; fels kt bit 1-be -> mindig csak az utols sort mdostja
	set	7,c
	xor	a
pwait1:	ld	hl,(playadr)
	res	7,h			; cm fels kt bitje 01b -> U1 RAM cmzse
	set	6,h
	or	a
	sbc	hl,de			; cmek sszehasonltsa
	jr	nz,pwait0		; vrakozs, amg a lejtszs nem tart a legutbb beolvasott adatoknl
	ld	(progres),bc
	ret


;
;
; 	Hasznlatlan FCB kitltse
;	in:  DE - kitltend FCB elejre mutat
;	     HL - berand 8+3-as fjlnv
;	out: -
;
fk_fcb:	push	hl
	ld	h,d			; HL is az FCB elejre mutat
	ld	l,e
	xor	a
	ld	b,030h			; 48 bjt trlse
fk_fcb0:ld	(de),a
	inc	de
	djnz	fk_fcb0
	ld	(hl),0FFh		; hasznlatlan FCB jelzs
	ld	de,0006h
	add	hl,de
	ld	(hl),000h		; keressi attributum (nem keres ktet azonostt)
	inc	hl
	ld	(hl),000h		; 0 -> aktulis meghajt
	inc	hl
	pop	de			; DE= 8+3 bjtos fjlnv
	ex	de,hl
	ld	bc,0000Bh		; 8+3 bjtos fjlnv tmsolsa
	ldir				; a tbbi vltoz nulla
	ret


;
;
;	Hangfjl megnyitsa
;	in:  HL - 8+3 (11 karakteres) fjlnvre mutat (az aktulis knyvtrban keresi)
;	out:  A - hibakd
;	     ZF - ZF=1 -> nem volt hiba  ZF=0 -> hiba volt
;
rw4open:ld	de,FCB_1		; FCB1 kitltse hasznlatlan FCB-knt a megadott nvvel
	call	fk_fcb
	ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= hasznlatlan FCB (aminek megfelel fjlt keres)
	ld	hl,nulpath		; HL= tvonalnv kezdete
	ld	a,004h			; A = FISH funkci: els keresse
	call	0008h			; FISH funkci hvsa
	or	a
	ret	nz			; visszatrs, ha hiba volt
	ld	de,FCB_0		; FCB_0 a tallt meghatrozott FCB
	ld	hl,FCB_1		; FCB_1 a keressi FCB
	ld	a,00Ch			; A = FISH funkci: fjl megnyitsa
	call	0008h			; FISH funkci hvsa
	or	a
	ret	nz			; visszatrs, ha hiba volt
	ld	hl,(FCB_0 + 017h)	; HL= fjlmret 8kB-os maradka
	ld	d,h
	ld	a,h
	and	01Fh
	ld	h,a
	ld	(lsblokk),hl		; utols blokkban lv bjtok szmnak mentse
	ld	a,d			; A reg.= fjlmret als sz fels bjtja
	ld	hl,(FCB_0 + 019h)	; HL= fjlmret fels szava
	add	a,a			; fjlmret osztsa 8kB-al (2000h)
	adc	hl,hl
	add	a,a
	adc	hl,hl
	add	a,a
	adc	hl,hl			; eredmny HL-ben
	ld	a,000h
	ret	z			; visszatrs, ha 0 az eredmny (hibt nem jelez)
	ld	(nblokk),hl		; blokkokszm mentse a ksbbiekre
;
	ld	hl,04000h		; els blokk beolvassa U1 RAM elejre
	ld	(rd_data),hl
	push	hl
	pop	ix			; IX= tltsi cm
	ld	de,FCB_0
	ld	bc,02000h		; BC= beolvasand bjtok (8192)
	ld	a,00Fh			; funkcikd: olvass fjlbl
	call	0008h			; FISH funkci hvsa
	or	a
	ret	nz			; visszatrs, ha hiba volt (8kB-nl rvidebb fjlokat sem dolgoz fel)
	ld	hl,04000h		; HL= olvasott adatok cme
	ld	a,'R'			; fejlc ellenrzse
	cp	(hl)
	ret	nz
	inc	hl
	ld	a,'W'
	cp	(hl)
	ret	nz
	inc	hl
	ld	a,'4'
	cp	(hl)
	ret	nz
	inc	hl
	ld	a,(hl)			; A reg.= RW4 fjl tpusa (most nem hasznlt)
	inc	hl
	ld	e,(hl)			; DE= mintavteli frekvencia PITCH rtke
	inc	hl
	ld	a,(hl)
	and	00Fh
	ld	d,a
	ld	(pitch),de		; PITCH rtk mentse a ksbbi felhasznlshoz
	xor	a			; hibakd trlse
	ret


;
;
;	Hangfjl lejtszsa
;	in:     -
;	out:  A - hibakd
;	     CY - CY=1 -> ESC-et nyomtak vagy lemezes hiba trtnt
;
rw4play:call	clrpbar			; progresszbr sornak letrlse
	call	setsnd			; lejtszs alaphelyzetbe lltsa, hang megszakts engedlyezse
;
	ld	hl,06000h		; kvetkez blokk beolvassa majd U1 RAM kzepre (folytats cirkulrisan)
	ld	(rd_data),hl
	ld	de,(nblokk)		; DE= 8kB-os blokkok szma
	ld	b,002h			; B a kls ciklus-szmll
	jr	beolv1			; folytats a blokkszm ellenrzsvel
;
beolv0:	push	bc
	push	de
	ld	b,h			; beolvasand bjszm BC-be
	ld	c,l
	ld	de,FCB_0		; DE= megnyitott FCB
	ld	ix,(rd_data)		; IX= tltsi cm
	ld	a,00Fh			; funkcikd: olvass fjlbl
	call	0008h			; FISH funkci hvsa
	or	a
	jr	nz,beolv2		; ugrs, ha hiba volt
;
	ld	de,(rd_data)		; DE= legutbbi tltsi cm
	call	pbwait			; vrakozs, amg a lejtszs nem ri el ezt a cmet
	ld	a,020h			; tltsi cm nvelse 8192-vel
	add	a,d
	and	03Fh			; cm fels kt bitje 01b -> U1 RAM cmzse
	or	040h
	ld	d,a
	ld	(rd_data),de		; j tltsi cm mentse
	call	chesc			; billentyzet vizsglata
	ld	a,c			; lenyomott gomb ASCII kdja A reg.-be
	pop	de			; DE= htralv blokkok szma
	pop	bc			; B = kls ciklus szmll
	cp	01Bh
	jr	z,beolv3		; ugrs, ha ESC-et nyomtak (ilyenkor A reg.= 01Bh)
beolv1:	ld	hl,02000h		; HL= beolvasand bjtok (8192)
	dec	de			; blokkszm cskkentse
	ld	a,e
	or	d
	jr	nz,beolv0		; ugrs, ha van mg htra 8kB-os blokk
	inc	de			; blokkszm visszanvelse az utols rszblokkhoz
	ld	hl,(lsblokk)		; HL= utols blokkban lv bjtok szma
	djnz	beolv0			; ugrs az utols lejtszsi ciklus kezdetre a maradk bjtokkal
	push	ix			; utoljra olvasott bjt cme a verembe
	pop	de			; cm DE-be
	call	pbwait			; vrakozs, amg a lejtszs nem ri el ezt a cmet
	xor	a			; hibakd trlse
	jr	beolv3			; ugrs a befejezsre
;
beolv2:	pop	de
	pop	bc
beolv3:	push	af
	call	resint			; megszaktsok helyrelltsa
	call	clrpbar			; progresszbr sornak letrlse
	pop	af
	or	a			; CY=0
	ret	z			; visszatrs, ha nem volt hiba
	scf				; CY=1
	ret


.end
